import config
import function
import logging
import mqtt
import report
import time

logger = logging.getLogger(config.APP_NAME)

# TODO: Extend virtual devices and implement all_off functionality in function.all_functions.init_off_functionality
#         * All Off
#         * ...
# TODO: Restructure nodered gui (own heating page - with circulation pump)
# TODO: Extend tests in simulation
#         - Synch functions (ffe.livingroom.floorlamp [with main_light and 1-6], ffe.diningroom/floorlamp, ffe.dirk.amplifier (with spotify, mpd, cd_player), gfw.floor.main_light)
#         - Remote actions after amplifier on
#         - Switching button functions (gfw_dirk, ffe.sleep)
#         - Heating functionality (base: set temp, set default, away_mode, summer_mode, start and stop boost)
#         - Brightness button functions (gfw.dirk, ffe.sleep)
#         - Motion stairways (incl. sensor feedback)
#         - Heating functionality (extended: timer)
#         - Timer (circulation and stairways)
# TODO: Rework devices to base.mqtt (pack -> set, ...)
# TODO: Implement handling of warnings (videv element to show in webapp?)


if __name__ == "__main__":
    if config.DEBUG:
        report.appLoggingConfigure(None, None, ((config.APP_NAME, logging.DEBUG), ), fmt=report.SHORT_FMT, host='localhost', port=19996)
    else:
        report.stdoutLoggingConfigure(((config.APP_NAME, logging.INFO), ), report.SHORT_FMT)
    #
    mc = mqtt.mqtt_client(host=config.MQTT_SERVER, port=config.MQTT_PORT, username=config.MQTT_USER,
                          password=config.MQTT_PASSWORD, name=config.APP_NAME)

    func = function.all_functions(mc)

    while (True):
        time.sleep(1)
